package clustering;

public class FuzzyKMeansState extends KMeansState {
    
    public double[][] fuzzyCluster;
    public transient FuzzyKMeansClustering fkmc;
    public double epsilon;
   
    
    public FuzzyKMeansState(){
    }
    
    public FuzzyKMeansState(Object[] data, int dataCount){
        this.data=data;
        this.dataCount=dataCount;
    }
    
    public FuzzyKMeansState(Object[] data, int dataCount, int clusterCount){
        this.data=data;
        this.dataCount=dataCount;
        this.clusterCount=clusterCount;
    }
    
    public FuzzyKMeansState(FuzzyKMeansClustering fkmc,Object[] data, int dataCount, int clusterCount){
        this.data=data;
        this.dataCount=dataCount;
        this.clusterCount=clusterCount;
        this.fkmc=fkmc;
    }
    
    
    
    public Object clone(){
        FuzzyKMeansState state=null;
        state=(FuzzyKMeansState)super.clone();
        state.fuzzyCluster=new double[fuzzyCluster.length][fuzzyCluster[0].length];
        for (int i=0;i<fuzzyCluster.length;i++)
            for (int j=0;j<fuzzyCluster[0].length;j++){
                state.fuzzyCluster[i][j]=fuzzyCluster[i][j];
            }
        state.epsilon=epsilon;
        return state;
    }
}
