/*
 * Created on 24.04.2003
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code Template
 */
package pipes;

import clustering.AbstractFuzzyKMeans;
import clustering.FuzzyAverages;
import clustering.FuzzyKMeans;
import clustering.FuzzyKMeansUtils;
import clustering.KMeansUtils;
import clustering.PossibilisticKMeans;
import clustering.RelativeFuzzyKMeans;

/**
 * @author beringer
 */
public class FuzzyStreamCluster extends FuzzyStreamingKMeans {

    public FuzzyStreamCluster(String[] streamNames, int windowSize,
            int blockCount, int dftCount, int clusterCount, double fuzzifier) {
        this(streamNames, windowSize, blockCount, dftCount, clusterCount,
                clusterCount, clusterCount, fuzzifier);
    }

    /** Creates a new instance of StreamCluster */
    public FuzzyStreamCluster(String[] streamNames, int windowSize,
            int blockCount, int dftCount, int maxClusterCount,
            int minClusterCount, int clusterCount, double fuzzifier) {

        super(new RelativeFuzzyKMeans(new PossibilisticKMeans(
                DFTNormWeightedStreams.getDFTDistance(dftCount), fuzzifier,
                // FuzzyKMeans.OBJECTIVE,
                AbstractFuzzyKMeans.MYVF3, FuzzyKMeansUtils.INITALIZE,
                KMeansUtils.getComplexCopyFunction(dftCount), FuzzyAverages
                        .getComplexMeansFunction(dftCount))), streamNames,
                        windowSize, blockCount, maxClusterCount, minClusterCount,
                clusterCount);

    }

    public FuzzyStreamCluster(FuzzyKMeans kMeansAlgorithm,
            String[] streamNames, int windowSize, int blockCount,
            int maxClusterCount, int minClusterCount, int clusterCount) {

        super(new RelativeFuzzyKMeans(kMeansAlgorithm), streamNames, windowSize,
                blockCount, maxClusterCount, minClusterCount, clusterCount);

    }

    public FuzzyStreamCluster(String[] streamNames, int windowSize,
            int blockCount, int dftCount, int maxClusterCount,
            int minClusterCount, int clusterCount, double fuzzifier,
            double noiseDistance) {

        super(new RelativeFuzzyKMeans(new FuzzyKMeans(DFTNormWeightedStreams
                .getDFTDistance(dftCount), fuzzifier, FuzzyKMeans.OBJECTIVE,
                AbstractFuzzyKMeans.MYVF3, FuzzyKMeansUtils.INITALIZE,
                KMeansUtils.getComplexCopyFunction(dftCount), FuzzyAverages
                        .getComplexMeansFunction(dftCount), noiseDistance)),
                        streamNames, windowSize, blockCount, maxClusterCount,
                minClusterCount, clusterCount);

    }

}
